# -*- coding: utf-8 -*-
"""
Created on Tue Oct 14 17:55:58 2014

@author: david
"""

import matplotlib.pyplot as plt
import numpy as np

def Escargot(f,u0,n,xmin,xmax,n_debut=0):
    u = u0
    abscisse = [u]
    ordonnee = [0]
    for i in range(0,n):
        abscisse = abscisse + [u]
        u = f(u)
        abscisse = abscisse + [u]
        ordonnee = ordonnee + [u,u]
    abscisse = abscisse[2*n_debut:]
    ordonnee = ordonnee[2*n_debut:]
    plt.plot(abscisse,ordonnee,'ko-') #l’escalier
    x = np.linspace(xmin,xmax) #les abscisses des points
    y = [f(t) for t in x] #les ordonnées de f
    plt.plot(x,y,'r-') #le graphe de f
    plt.plot(x,x,'g-') #la bissectrice
    plt.axhline(color='k') #les axes x...
    plt.axvline(color='k') #et y
    plt.show()

def f(l):
    return lambda x : l*x*(1-x)

def g(x):
    return np.exp(1.3*(x-1))

# Quelques exemples

Escargot(f(2),0.17,50,0,1)
Escargot(f(3),0.17,100,0,1)
Escargot(f(3),0.17,1050,0,1,1000)
Escargot(f(3.1),0.17,1000,0,1,900)
Escargot(f(3.4),0.17,1000,0,1,900)
Escargot(f(3.54),0.17,10000,0,1,9000)
Escargot(f(3.57),0.17,10000,0,1,9000)
